#!/usr/bin/python2.4
# -*- coding: utf-8 -*-

import math

class VectorType:
    NONE = 0
    LINE = 1
    ARC  = 2
    TEXT = 3

class MultipassTypeEnum:
    GLOBAL = 0
    LOCAL = 1

class GcodeTypeEnum:
    NORMAL = 0
    SCAN = 1

class BaseImport:
    def __init__(self):
        pass

    def get_line_size(self, v):
        min = self.min
        max = self.max
        if v.begin.x < v.end.x:
            if v.begin.x < min.x:
                min.x = v.begin.x
            if v.end.x > max.x:
                max.x = v.end.x
        else:
            if v.end.x < min.x:
                min.x = v.end.x
            if v.begin.x > max.x:
                max.x = v.begin.x
        if v.begin.y < v.end.y:
            if v.begin.y < min.y:
                min.y = v.begin.y
            if v.end.y > max.y:
                max.y = v.end.y
        else:
            if v.end.y < min.y:
                min.y = v.end.y
            if v.begin.y > max.y:
                max.y = v.begin.y

    def get_arc_size(self, v):
        min = self.min
        max = self.max
        rad = math.radians
        angle_steps = (v.end_angle - v.start_angle)/360.0
        j = v.start_angle
        r = v.radius
        cx, cy = v.center.x, v.center.y
        while j < v.end_angle:
            anglerad = rad(j)
            nx = cx + r*math.cos(anglerad)
            ny = cy + r*math.sin(anglerad)

            if nx < min.x:
                min.x = nx
            elif nx > max.x:
                max.x = nx

            if ny < min.y:
                min.y = ny
            elif ny > max.y:
                max.y = ny
            j += angle_steps
